// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"errors"

	"go.opentelemetry.io/otel/metric"
	"go.opentelemetry.io/otel/metric/noop"
	"go.opentelemetry.io/otel/trace"

	"go.opentelemetry.io/collector/component"
	"go.opentelemetry.io/collector/config/configtelemetry"
)

func Meter(settings component.TelemetrySettings) metric.Meter {
	return settings.MeterProvider.Meter("otelcol/sumologic")
}

func Tracer(settings component.TelemetrySettings) trace.Tracer {
	return settings.TracerProvider.Tracer("otelcol/sumologic")
}

// TelemetryBuilder provides an interface for components to report telemetry
// as defined in metadata and user config.
type TelemetryBuilder struct {
	meter                    metric.Meter
	ExporterRequestsBytes    metric.Int64Counter
	ExporterRequestsDuration metric.Int64Counter
	ExporterRequestsRecords  metric.Int64Counter
	ExporterRequestsSent     metric.Int64Counter
	level                    configtelemetry.Level
}

// telemetryBuilderOption applies changes to default builder.
type telemetryBuilderOption func(*TelemetryBuilder)

// WithLevel sets the current telemetry level for the component.
func WithLevel(lvl configtelemetry.Level) telemetryBuilderOption {
	return func(builder *TelemetryBuilder) {
		builder.level = lvl
	}
}

// NewTelemetryBuilder provides a struct with methods to update all internal telemetry
// for a component
func NewTelemetryBuilder(settings component.TelemetrySettings, options ...telemetryBuilderOption) (*TelemetryBuilder, error) {
	builder := TelemetryBuilder{level: configtelemetry.LevelBasic}
	for _, op := range options {
		op(&builder)
	}
	var err, errs error
	if builder.level >= configtelemetry.LevelBasic {
		builder.meter = Meter(settings)
	} else {
		builder.meter = noop.Meter{}
	}
	builder.ExporterRequestsBytes, err = builder.meter.Int64Counter(
		"exporter_requests_bytes",
		metric.WithDescription("Total size of requests (in bytes)"),
		metric.WithUnit("By"),
	)
	errs = errors.Join(errs, err)
	builder.ExporterRequestsDuration, err = builder.meter.Int64Counter(
		"exporter_requests_duration",
		metric.WithDescription("Duration of HTTP requests (in milliseconds)"),
		metric.WithUnit("ms"),
	)
	errs = errors.Join(errs, err)
	builder.ExporterRequestsRecords, err = builder.meter.Int64Counter(
		"exporter_requests_records",
		metric.WithDescription("Total size of requests (in number of records)"),
		metric.WithUnit("{records}"),
	)
	errs = errors.Join(errs, err)
	builder.ExporterRequestsSent, err = builder.meter.Int64Counter(
		"exporter_requests_sent",
		metric.WithDescription("Number of requests"),
		metric.WithUnit("1"),
	)
	errs = errors.Join(errs, err)
	return &builder, errs
}
